/*EHRLER FREDERIC											
 * -----------------------------------------------------------------------
 * classe qui retourne differente primitives geometrique.
 */

import java.util.Vector; 
import java.awt.*;

public class GeomTools{


/* ici trois differente methode qui font la meme chose mais qu'on apelle
 * avec differents set de donnee
 */
	public static Vector getPointBetween(int x1, int y1, int x2, int y2){
    	int[] point1 = new int[2];
    	int[] point2 = new int[2];
    	point1[0] = x1;
    	point1[1] = y1;
    	point2[0] = x2;
    	point2[1] = y2;
    	return calculatePointBetween(point1, point2);
	}
	
	public static Vector getPointBetween(Point p1,Point p2){
    	int[] point1 = new int[2];
    	int[] point2 = new int[2];
    	point1[0] = (int)p1.getX();
    	point1[1] = (int)p1.getY();
    	point2[0] = (int)p2.getX();
    	point2[1] = (int)p2.getY();
		return calculatePointBetween(point1, point2);
    }
    
	public static Vector getPointBetween(int[] point1, int[] point2){
		return calculatePointBetween(point1, point2);
    }
    
  public static int[] getMiddlePoint(int x1, int y1, int x2, int y2){
    	int[] middlePoint = new int[2];
    	double diffX = (x2 - x1);
    	double diffY = (y2 - y1);
      double pente = diffY/diffX;
    	double ordonnee = y1 - x1*pente;
   		double middleX = x1+diffX/2.0;
   		double middleY = pente*middleX+ordonnee;
   		System.out.println(" le point milieu, entre "+x1+","+y1+" et "+x2+","+y2+" := "+middleX+","+middleY);
   		middlePoint[0] = (int)middleX; 
   		middlePoint[1] = (int)middleY;
   		
   		return middlePoint;
    }
	
	// slope = pente;
	public static double getSlope(int x1, int y1, int x2, int y2){
		double diffX = (x2 - x1);
    	double diffY = (y2 - y1);
       	double pente = diffY/diffX;
		return pente;
	}
	
	public static double getOrdinate(int x1, int y1, int x2, int y2){
		double diffX = (x2 - x1);
    	double diffY = (y2 - y1);
       	double pente = diffY/diffX;
       	double ordonnee = x1 - y1*pente;
    	return ordonnee;
	}
	
	
/** methode qui nous calcule tout les point se situant entre deux autres,
 * cela nous permet d'avoir tout les points du trace afin de le sauver dans
 * une matrice
 */
	private static Vector calculatePointBetween(int[] point1, int[] point2){
		Vector listeDePoint = new Vector();
		double pente = (double)((double)(point1[1]-point2[1])/(double)(point1[0]-point2[0]));
		double ordonnee;
		if (point1[0] == 0){
			ordonnee = point1[1];
		} else {
			ordonnee = (double)(point1[1]-(point1[0]*pente));
		}
		int increment = 1;
		//int increment = -(point1[0]-point2[0])/Math.abs(point1[0]-point2[0]);
		System.out.println("les points sonts :"+point1[0]+";"+point1[1]+";"+point2[0]+";"+point2[1]);
		System.out.println("increment:= "+increment);
		System.out.println("pente:= "+pente);
		System.out.println("ordonnee:= "+ordonnee);
		
		if (point1[0]<point2[0]){
			System.out.println("point1[0]<point2[0]");
			for (int i=point1[0]; i < point2[0]+1; i = i+increment ){
				int[] tempPoint = new int[2];
				tempPoint[0]=i;
				tempPoint[1] = (int)(i*pente + ordonnee);
				System.out.println("nouveau point := "+tempPoint[0]+" ; "+tempPoint[1]);
				listeDePoint.add(tempPoint);
			}
		} 
		
		if (point1[0]>point2[0]){
			System.out.println("point1[0]>point2[0]");
			for (int i=point2[0]; i < point1[0]+1; i = i+increment ){
				int[] tempPoint = new int[2];
				tempPoint[0]=i;
				tempPoint[1] = (int)(i*pente + ordonnee);
				System.out.println("nouveau point := "+tempPoint[0]+" ; "+tempPoint[1]);
				listeDePoint.add(tempPoint);
			}
		}	
		
		
//-----------------------------------------------------------------------------------------
		if (point1[0] == point2[0]){
			System.out.println("point1[0]=point2[0]");
			if (point1[1]<point2[1]){
				for (int i=point1[1]; i < point2[1]+1; i = i+increment ){
					int[] tempPoint = new int[2];
					tempPoint[1] = i;
					tempPoint[0] = point1[0];
					System.out.println("nouveau point := "+tempPoint[0]+" ; "+tempPoint[1]);
					listeDePoint.add(tempPoint);
				}
			}
			if (point1[1]>point2[1]){
				for (int i=point2[1]; i < point1[1]+1; i = i+increment ){
					int[] tempPoint = new int[2];
					tempPoint[1] = i;
					tempPoint[0] = point1[0];
					System.out.println("nouveau point := "+tempPoint[0]+" ; "+tempPoint[1]);
					listeDePoint.add(tempPoint);
				}
			}
		} 	 
			
//------------------------------------------------------------------------------------------			
		if (point1[0] != point2[0]){
			System.out.println("point1[0]==point2[0]");
			if (point1[1]<point2[1]){
				System.out.println("point1[1]<point2[1]");
				for (int i=point1[1]; i < point2[1]+1; i = i+increment ){
					int[] tempPoint = new int[2];
					tempPoint[1] = i;
					tempPoint[0] = (int)((i - ordonnee)/pente);
					System.out.println("nouveau point := "+tempPoint[0]+" ; "+tempPoint[1]);
					listeDePoint.add(tempPoint);
				}
			} 
			
			if (point1[1]>point2[1]){
				System.out.println("point1[1]>point2[1]");
				for (int i=point2[1]; i < point1[1]+1; i = i+increment ){
					int[] tempPoint = new int[2];
					tempPoint[1] = i;
					tempPoint[0] = (int)((i - ordonnee)/pente);
					System.out.println("nouveau point := "+tempPoint[0]+" ; "+tempPoint[1]);
					listeDePoint.add(tempPoint);
				}
			}
		}
		return (listeDePoint);
    } 	


	public static double getAngleBetween(int x1, int y1, int x2, int y2){
	    int[] point1 = new int[2];
    	int[] point2 = new int[2];
    	point1[0] = x1;
    	point1[1] = y1;
    	point2[0] = x2;
    	point2[1] = y2;
    	return calculateAngleBetween(point1, point2);
	}
	
	
	public static double calculateAngleBetween(int[] point1,int[] point2){
		double angle = 0;
		int diffX = Math.abs(point1[0]-point2[0]);
		int diffY = Math.abs(point1[1]-point2[1]);
		System.out.println("diffX := "+diffX);
		System.out.println("diffY := "+diffY);
		int x1 = point1[0];
		int y1 = point1[1];
		int x2 = point2[0];
		int y2 = point2[1];
		System.out.println("pt1:= "+x1+","+y1+" pt2:= "+x2+","+y2);
		
		System.out.println("calcule de l'angle de depart --------------------->");
		System.out.println("point1 de l'arrivee:= "+point1[0]+","+point1[1]);
		System.out.println("point2 de l'arrivee:= "+point2[0]+","+point2[1]);
		
		//System.out.println("diffX/diffY := "+(double)((double)diffX/(double)diffY));
		//angleDepart = Math.atan((double)((double)diffX/(double)diffY));
		if ((x1==x2) && (y1<y2)){
			System.out.println("situation (x1==x2) && (y1<y2)");
			angle = Math.toRadians(270);
		}
		if ((x1<x2) && (y1==y2)){
			System.out.println("situation (x1<x2) && (y1==y2)");
			angle = Math.toRadians(0);
		}
		if ((x1==x2) && (y1>y2)){
			System.out.println("situation (x1==x2) && (y1>y2)");
			angle = Math.toRadians(90);
		}
		if ((x1>x2) && (y1==y2)){
			System.out.println("situation (x1<x2) && (y1==y2)");
			angle = Math.toRadians(180);
		}
		if ((x1<x2) && (y1>y2)){
			System.out.println("situation (x1<x2) && (y1>y2)");
			angle = Math.toRadians(360) - Math.atan((double)Math.abs(y2-y1)/Math.abs(x2-x1));
		}
		if ((x1>x2) && (y1>y2)){
			System.out.println("situation (x1>x2) && (y1>y2)");
			angle = Math.toRadians(180) + Math.atan((double)Math.abs(y2-y1)/Math.abs(x2-x1));
		}
		if ((x1>x2) && (y1<y2)){
			System.out.println("situation (x1>x2) && (y1<y2)");
			angle = Math.toRadians(180) - Math.atan((double)Math.abs(y2-y1)/Math.abs(x2-x1));	
		}
		if ((x1<x2) && (y1<y2)){
			System.out.println("situation (x1<x2) && (y1<y2)");
			angle = Math.atan((double)Math.abs(y2-y1)/Math.abs(x2-x1));	
		}
		
		// on ajoute 90 car on doit etre perpendiculaire a l'angle 
		// de la ligne d'arrivee qui a ete calcule
		System.out.println("angle calcule = "+angle);
		System.out.println("angle calcule en degre = "+Math.toDegrees(angle));
		return angle;
	}
	
	
	public static int[] getGravityCenter(int[][] point){
		int[] center = new int[2];
		int centerX = 0;
		int centerY = 0;
		for (int i=0; i<point.length; i++){
			centerX = centerX+point[i][0];
			centerY = centerY+point[i][1];
		}
		System.out.println("centerX := "+centerX+" centerY:= "+centerY);
		centerX = centerX/point.length;
		centerY = centerY/point.length;
		center[0] = centerX;
		center[1] = centerY;
		
		return center;
	}
	
	public static void main(String args[]){
		getMiddlePoint(10,10,100,100);
		getMiddlePoint(100,10,10,100);
		getMiddlePoint(10,100,100,10);
		getMiddlePoint(100,100,10,10);
		getMiddlePoint(30,25,107,180);
	}
}