/* EHRLER FREDERIC - MICHEL DERIAZ
 * ------------------------------------------------------------------
 * cette classe est en faite une structure de donnee qui permet de
 * transmettre tout les reglages de l'image decides a travers 
 * l'interface jusqu'a l'objet qui s'occupe de gerer la collection 
 * d'image.
 * toutes les methode accessible sont donc soit des get() soit des set()
 */

import java.util.Vector;
import javax.swing.JCheckBox;

class ParamDistributor {
	int gamma;
	int BWSeuil;
	int RSeuil;
	int GSeuil;
	int BSeuil;
	int nbPasse;
	int tailleFiltre;
	int borderValue;
	int borderSize;
	int colorOpDiff;
	int colorOpMinSeuil;
	int blackValue;
	int decalageX;
	int decalageY;
	int redCylSurf;
	int greenCylSurf;
	int blueCylSurf;
	int RSelectSeuilMin;
	int RSelectSeuilMax;
	int GSelectSeuilMin;
	int GSelectSeuilMax;
	int BSelectSeuilMin;
	int BSelectSeuilMax;
	int redBord;
	int greenBord;
	int blueBord;
	int robotSizeX;
	int robotSizeY;
	int robotBord;
	int largMaxDoorHoriz;
	int largMaxDoorVert;
	
	Vector calulatedImage;
	
	boolean quadrillage;
	boolean requestRed;
	boolean	requestGreen;
	boolean	requestBlue;
	boolean	requestWall;
	boolean	requestRobot;	
		
	boolean rescale = false;
	boolean filter = false;
	boolean border = false;
	boolean droite = false;
	boolean gauche = false;
	
	
	public void setSeuil(int RSeuil, int GSeuil, int BSeuil){
		this.RSeuil=RSeuil;
		this.GSeuil=GSeuil;
		this.BSeuil=BSeuil;
	}
	
	public void setGamma(int gamma){
		this.gamma = gamma;
	}
		
	public void setBWSeuil(int BWSeuil){
		this.BWSeuil=BWSeuil;
	}	
	
	public void setRSeuil(int RSeuil){
		this.RSeuil=RSeuil;
	}
	
	public void setGSeuil(int GSeuil){
		this.GSeuil=GSeuil;
	}
	
	public void setBSeuil(int BSeuil){
		this.BSeuil=BSeuil;
	}

	public void setNbPasse(int nbPasse){
		this.nbPasse = nbPasse;
	}

	public void setTailleFiltre(int tailleFiltre){
		this.tailleFiltre = tailleFiltre;
	}
	
	public void setBorderValue(int borderValue){
		this.borderValue = borderValue;
	}
	
	public void setBorderSize(int borderSize){
		this.borderSize = borderSize;
	}
		
	public void setColorOpDiff(int colorOpDiff){
		this.colorOpDiff = colorOpDiff;
	}
	
	public void setColorOpMinSeuil(int colorOpMinSeuil){
		this.colorOpMinSeuil = colorOpMinSeuil;
	}
	
	public void setBlackValue(int blackValue){
		this.blackValue = blackValue;
	}

	public void setDecalageX(int decalageX){
		this.decalageX = decalageX;
	}
	
	public void setDecalageY(int decalageY){
		this.decalageY = decalageY;
	}
	
	public void setRedCylSurf(int redCylSurf){
		this.redCylSurf = redCylSurf;
	}
		public void setGreenCylSurf(int greenCylSurf){
		this.greenCylSurf = greenCylSurf;
	}
		public void setBlueCylSurf(int blueCylSurf){
		this.blueCylSurf = blueCylSurf;
	}
	
	
	public void setLargMaxDoorHoriz(int largMaxDoorHoriz){
		this.largMaxDoorHoriz = largMaxDoorHoriz;
	}
	
	public void setLargMaxDoorVert(int largMaxDoorVert){
		this.largMaxDoorVert = largMaxDoorVert;
	}	
	
	
/////////////////////////////////////////////////////////////////////////	
	public void setCalculatedImage(Vector calulatedImage){
		this.calulatedImage = new Vector();
		for (int i=0;i<calulatedImage.size();i++){
			this.calulatedImage.add(new Boolean(((JCheckBox)calulatedImage.get(i)).isSelected()));
		}
	}
	

	public void setSelectColorSeuilR(int seuilRMin, int seuilRMax){
		this.RSelectSeuilMin = seuilRMin;
		this.RSelectSeuilMax = seuilRMax;
		System.out.println("setting de parametre red : "+RSelectSeuilMin+";"+RSelectSeuilMax+"---------");
	}
	
	public void setSelectColorSeuilG(int seuilGMin, int seuilGMax){
		this.GSelectSeuilMin = seuilGMin;
		this.GSelectSeuilMax = seuilGMax;
	}
	
	public void setSelectColorSeuilB(int seuilBMin, int seuilBMax){
		this.BSelectSeuilMin = seuilBMin;
		this.BSelectSeuilMax = seuilBMax;
	}
	
	public void setRedBord(int redBord){
		this.redBord = redBord;
	}
		public void setGreenBord(int greenBord){
		this.greenBord = greenBord;
	}
		public void setBlueBord(int blueBord){
		this.blueBord = blueBord;
	}
	
	public void setRobotSizeX(int robotSizeX){
		this.robotSizeX = robotSizeX;
	}
	public void setRobotSizeY(int robotSizeY){
		this.robotSizeY = robotSizeY;
	}
		public void setRobotBord(int robotBord){
		this.robotBord = robotBord;
	}

	public void setRequestRed(boolean requestRed){
		this.requestRed = requestRed;
	}
	public void setRequestGreen(boolean requestGreen){
		this.requestGreen = requestGreen;
	}
		public void setRequestBlue(boolean requestBlue){
		this.requestBlue = requestBlue;
	}
		public void setRequestWall(boolean requestWall){
		this.requestWall = requestWall;
	}
		public void setRequestRobot(boolean requestRobot){
		this.requestRobot = requestRobot;
	}

	public void setQuadrillage(boolean quadrillage){
		this.quadrillage = quadrillage;
	}

	public void setGauche(boolean gauche){
		this.gauche = gauche;
	}
	
	public void setDroite(boolean droite){
		this.droite = droite;
	}
		
	public void setRescale(boolean rescale){
		this.rescale = rescale;
	}
	
	public void setFilter(boolean filter){
		this.filter = filter;
	}
	
	public void setBorder(boolean border){
		this.border = border;
	}
	
	public int getBWSeuil(){
		return BWSeuil;
	}
	
	public int getRSeuil(){
		return RSeuil;
	}
	
	public int getGSeuil(){
		return GSeuil;
	}
	
	public int getBSeuil(){
		return BSeuil;
	}
	
	public int getGamma(){
		return gamma;
	}
	
	public int getNbPasse(){
		return nbPasse;
	}
	
	public int getTailleFiltre(){
		return tailleFiltre;
	}
	
	public int getBorderValue(){
		return borderValue;
	}
	
	public int getBorderSize(){
		return borderSize;
	}
	
	public int getColorOpDiff(){
		return colorOpDiff;
	}
	
	public int getColorOpMinSeuil(){
		return colorOpMinSeuil;
	}
	
	public int getBlackValue(){
		return blackValue;
	}
	
	public int getDecalageX(){
		return decalageX;
	}
	
	public int getDecalageY(){
		return decalageY;
	}

	public int getRedCylSurf(){
		return redCylSurf;
	}
	
	public int getGreenCylSurf(){
		return greenCylSurf;
	}
	
	public int getBlueCylSurf(){
		return blueCylSurf;
	}
	
	
	public int getRedBord(){
		return redBord;
	}
	
	public int getGreenBord(){
		return greenBord;
	}
	
	public int getBlueBord(){
		return blueBord;
	}

	public int getRobotSizeX(){
		return robotSizeX;
	}
	
	public int getRobotSizeY(){
		return robotSizeY;
	}
	
	public int getRobotBord(){
		return robotBord;
	}
	
	public int getLargMaxDoorHoriz(){
		return largMaxDoorHoriz;
	}
	
	public int getLargMaxDoorVert(){
		return largMaxDoorVert;
	}
	
	public int getMinRobotSize(){
		return Math.min(robotSizeX,robotSizeY);
	}
	
	public int getMaxRobotSize(){
		return Math.max(robotSizeX,robotSizeY);
	}
	
	
	public int[] getSelectColorSeuilR(){
		int[] selectSeuilR = new int[2];
		selectSeuilR[0] = RSelectSeuilMin;
		selectSeuilR[1] = RSelectSeuilMax;
		return selectSeuilR;
	}
	
	public int[] getSelectColorSeuilG(){
		int[] selectSeuilG = new int[2];
		selectSeuilG[0] = GSelectSeuilMin;
		selectSeuilG[1] = GSelectSeuilMax;
		return selectSeuilG;
	}
	
	public int[] getSelectColorSeuilB(){
		int[] selectSeuilB = new int[2];
		selectSeuilB[0] = BSelectSeuilMin;
		selectSeuilB[1] = BSelectSeuilMax;
		return selectSeuilB;
	}
		
	public boolean getRequestRed(){
		return requestRed;
	}
		public boolean getRequestGreen(){
		return requestGreen;
	}
		public boolean getRequestBlue(){
		return requestBlue;
	}
		public boolean getRequestWall(){
		return requestWall;
	}
		public boolean getRequestRobot(){
		return requestRobot;
	}
		
	public boolean getQuadrillage(){
		return quadrillage;
	}	
		
	public boolean getRescale(){
		return rescale;
	}
	
	public boolean getFilter(){
		return filter;
	}
	
	public boolean getBorder(){
		return border;
	}
	
	public boolean getGauche(){
		return gauche;
	}
		public boolean getDroite(){
		return droite;
	}
	
	public boolean isCalculatedImage(int noImage){
		boolean result = ((Boolean)calulatedImage.get(noImage)).booleanValue();
		return result;
	}
}