// Updates: 2002.06.10


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class Goal {
  static final int DIAMETER = 64; // A mesurer !
  int x, y;
  int index;
  
  
  public Goal(int index, int x, int y) {
    this.index = index;
    this.x = x;
    this.y = y;
  }
  
    
  public void paint(Graphics g) {
    if (index == 0) g.setColor(Color.blue);
    if (index == 1) g.setColor(Color.green);
    if (index == 2) g.setColor(Color.red);
    g.drawOval(x-DIAMETER/2, y-DIAMETER/2, DIAMETER, DIAMETER);
    g.drawOval(x-DIAMETER/2-1, y-DIAMETER/2-1, DIAMETER+1, DIAMETER+1);
  }
  
   
  public Point getPosition() {
    return new Point(x, y);
  }
  
  
  public int getX() {
    return x;
  }
  
  
  public int getY() {
    return y;
  }
  
  
  public void setPosition(Point p) {
    setPosition(p.x, p.y);
  }
  
  
  public void setPosition(int x, int y) {
    this.x = x;
    this.y = y;
  }  
}