// Updates: 2002.05.18


import josx.robotics.*;
import josx.rcxcomm.*; 
import josx.platform.rcx.*;
import josx.util.*;
import java.io.*;


public class RCXReceiver implements SensorListener {


  public RCXReceiver() {
    Sensor.S2.addSensorListener(this);
    RCXPort port = null;
    try {
      port = new RCXPort(); 
    }
    catch (IOException e) {}
    DataInputStream in = new DataInputStream(port.getInputStream());          
    while (true) {
      try {
        short msg = in.readShort();
        if (msg == 1) {
          Motor.A.forward();
          Motor.C.forward();
        }
        if (msg == 2) {
          Motor.A.backward();
          Motor.C.forward();
        }     
        if (msg == 3) {
          Motor.A.stop();
          Motor.C.stop();
        }     
        if (msg == 4) {
          Motor.A.forward();
          Motor.C.backward();
        }     
        if (msg == 5) {
          Motor.A.backward();
          Motor.C.backward();
        }                        
      }
      catch (IOException e) {}
    }
  }    

    
  public static void main(String[] args) {
    Serial.setRangeLong();
    new RCXReceiver();
  }
  

  public void stateChanged(Sensor aSource, int aOldValue, int aNewValue) {
    if (Sensor.S2.readBooleanValue()) {
      Motor.A.stop();
      Motor.C.stop();      
    }
  }
}    