/* EHRLER FREDERIC - MICHEL DERIAZ
 * ------------------------------------------------------------------
 * cette classe s'occupe de construire toute l'interface, afin de 
 * pouvoir regler tout les parametre de l'analyse d'image.
 */


import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.image.*;
import java.io.*;

public class ControlDisplayer implements ActionListener{
	JFrame fenetre;
	JPanel mainPanel;
	JPanel imagePanel;
	
	ImageDisplayer imageRef;
	int nbDisplayableImage = 12;
	
	final int initSeuilBWSlider = 140;
	final int initSeuilRSlider = 50;
	final int initSeuilGSlider = 120;
	final int initSeuilBSlider = 120;
	final String initRobotX = "30";
	final String initRobotY = "20";
	final String initBordRobot = "0";
	final String initDecalageX = "60";
	final String initDecalageY = "40";
	final String initLargDoorHoriz = "8";
	final String initLargDoorVert = "8";
	
	final int initBlackSlider = 200;
	final int initGammaValue = 3;
	final int initRSeuilMin = 190;
	final int initRSeuilMax = 145;
	final int initGSeuilMin = 145;
	final int initGSeuilMax = 163;
	final int initBSeuilMin = 160;
	final int initBSeuilMax = 179;
	final int initcolorOpDiffSlider = 30;
	final int initcolorOpMinSeuilSlider = 90;
	
	
	
	Vector imageVector;
	Vector checkBoxVector;
		
//	JRadioButton plusGrand  = new JRadioButton(">",true);
//	JRadioButton plusPetit  = new JRadioButton("<",false);
//	JRadioButton egal       = new JRadioButton("=",false);

	JSlider seuilBWSlider;
	JSlider seuilRSlider;
	JSlider seuilGSlider;
	JSlider seuilBSlider;
	JSlider gammaSlider;	
	JSlider	colorOpDiffSlider;
	JSlider	colorOpMinSeuilSlider;
	JSlider blackSlider;
	JSlider	SRSeuilMin;
	JSlider	SRSeuilMax;
	JSlider	SGSeuilMin;
	JSlider	SGSeuilMax;
	JSlider	SBSeuilMin;
	JSlider	SBSeuilMax;
	
	JCheckBox rescaleBox;
	JCheckBox filteringBox;
	JCheckBox fillBorderBox;
	JCheckBox foundRegionBox;
	JCheckBox quadrillageBox;
	JCheckBox gauche;
	JCheckBox droite;
	JCheckBox[] imageName;
	
	JCheckBox	JCReqRed;
	JCheckBox	JCReqGreen;
	JCheckBox	JCReqBlue;
	JCheckBox	JCReqWall;
	JCheckBox	JCReqRobot;
	
	JTextField JTNbPasse;
	JTextField JTFilterSize;
	JTextField JTDecalageX;
	JTextField JTDecalageY;
	
	JTextField JTBorderSize;
	JTextField JTBorderValue;
	JTextField JTSurfRedCyl;
	JTextField JTSurfGreenCyl;
	JTextField JTSurfBlueCyl;
	JTextField JTRedTolerance;
	JTextField JTGreenTolerance;
	JTextField JTBlueTolerance;
	JTextField JTRedBord;
	JTextField JTGreenBord;
	JTextField JTBlueBord;
	JTextField JTRobotX;
	JTextField JTRobotY;
	JTextField JTBordRobot;
	
	JTextField JTLargDoorHoriz;
	JTextField JTLargDoorVert; 
	
	
	public ControlDisplayer(){
		fenetre = new JFrame("fenetre de controle");
		fenetre.addWindowListener(new WindowAdapter(){
    	public void windowClosing(WindowEvent e){
    		System.exit(0);
    	}
    });
		
		mainPanel = new JPanel();
		imagePanel = new JPanel();
		
		imageVector = new Vector();
		imageRef = new ImageDisplayer(320,240);
		
		for (int i=0;i<nbDisplayableImage; i++){
			imageVector.add(new ImageDisplayer(320,240));
		}
		((ImageDisplayer)imageVector.get(0)).setName("image de reference");
		((ImageDisplayer)imageVector.get(1)).setName("image modifiee");
		((ImageDisplayer)imageVector.get(2)).setName("image noir et blanc");
		((ImageDisplayer)imageVector.get(3)).setName("composante rouge");
		((ImageDisplayer)imageVector.get(4)).setName("composante verte");
		((ImageDisplayer)imageVector.get(5)).setName("composante bleu");
		((ImageDisplayer)imageVector.get(6)).setName("image des difference");
		((ImageDisplayer)imageVector.get(7)).setName("image selection couleur");
		((ImageDisplayer)imageVector.get(8)).setName("image resultat");
		((ImageDisplayer)imageVector.get(9)).setName("image selection rouge");
		((ImageDisplayer)imageVector.get(10)).setName("image selection vert");
		((ImageDisplayer)imageVector.get(11)).setName("image selection bleu");
		//((ImageDisplayer)imageVector.get(12)).setName("image soustraite");
		
		mainPanel.setLayout(new BorderLayout(5,5));
		//imagePanel.setLayout(new GridLayout(2,3));

		organiseView();
		
		fenetre.setContentPane(mainPanel);
		fenetre.pack();
		fenetre.show();
	}
	
	public void organiseView(){
		JPanel optionPanel = getOptionPanel();
		mainPanel.add(imagePanel,BorderLayout.NORTH);
		mainPanel.add(optionPanel,BorderLayout.SOUTH);
		
		JTabbedPane tabbedPane = new JTabbedPane();
	  JPanel page1 = new JPanel();
	  JPanel page2 = new JPanel();
	  JPanel page3 = new JPanel();
	  JPanel page4 = new JPanel();
	  
	  page1.setLayout(new BorderLayout(5,5));
	  page2.setLayout(new BorderLayout(5,5));
	  page3.setLayout(new BorderLayout(5,5));
	  page4.setLayout(new BorderLayout(5,5));
	  
	  page1.setBorder(BorderFactory.createTitledBorder("image recue // modifiee // noire et blanc"));
	  page2.setBorder(BorderFactory.createTitledBorder("composante de l'image R // G // B"));
		page3.setBorder(BorderFactory.createTitledBorder("image soustraite"));
		page4.setBorder(BorderFactory.createTitledBorder("image color"));
	  
	  imageName = new JCheckBox[nbDisplayableImage];
	  for (int i=0; i<nbDisplayableImage; i++){
	  	imageName[i] = new JCheckBox(((ImageDisplayer)imageVector.get(i)).getName(),true);
	  	imageName[i].addActionListener(this);
	  }
	  
	  JPanel imagePage1 = new JPanel();
	  JPanel imagePage2 = new JPanel();
	  JPanel imagePage3 = new JPanel();
	  JPanel imagePage4 = new JPanel();
	  JPanel checkBoxPage1 = new JPanel();
	  JPanel checkBoxPage2 = new JPanel();
	  JPanel checkBoxPage3 = new JPanel();
	  JPanel checkBoxPage4 = new JPanel();
	  
	  checkBoxPage1.setLayout(new GridLayout(1,3));
	  checkBoxPage2.setLayout(new GridLayout(1,3));
	  checkBoxPage3.setLayout(new GridLayout(1,3));
	  checkBoxPage4.setLayout(new GridLayout(1,3));
	  
	  checkBoxPage1.add(imageName[0]);
	  checkBoxPage1.add(imageName[1]);
	  checkBoxPage1.add(imageName[2]);
	  checkBoxPage2.add(imageName[3]);
	  checkBoxPage2.add(imageName[4]);
	  checkBoxPage2.add(imageName[5]);
	  checkBoxPage3.add(imageName[6]);
	  checkBoxPage3.add(imageName[7]);
	  checkBoxPage3.add(imageName[8]);
	  checkBoxPage4.add(imageName[9]);
	  checkBoxPage4.add(imageName[10]);
	  checkBoxPage4.add(imageName[11]);
	  
	  imagePage1.add(imageRef);
	  imagePage1.add((ImageDisplayer)imageVector.get(0));
	  imagePage1.add((ImageDisplayer)imageVector.get(1));
	  
	  imagePage2.add((ImageDisplayer)imageVector.get(2));
		imagePage2.add((ImageDisplayer)imageVector.get(3));
		imagePage2.add((ImageDisplayer)imageVector.get(4));
		
		imagePage3.add((ImageDisplayer)imageVector.get(5));
		imagePage3.add((ImageDisplayer)imageVector.get(6));
		imagePage3.add((ImageDisplayer)imageVector.get(7));
		
		imagePage4.add((ImageDisplayer)imageVector.get(8));
		imagePage4.add((ImageDisplayer)imageVector.get(9));
		imagePage4.add((ImageDisplayer)imageVector.get(10));
	  
	  
	  page1.add(imagePage1,BorderLayout.NORTH);
		page2.add(imagePage2,BorderLayout.NORTH);
		page3.add(imagePage3,BorderLayout.NORTH);
		page4.add(imagePage4,BorderLayout.NORTH);
		
		page1.add(checkBoxPage1,BorderLayout.SOUTH);
		page2.add(checkBoxPage2,BorderLayout.SOUTH);
		page3.add(checkBoxPage3,BorderLayout.SOUTH);
		page4.add(checkBoxPage4,BorderLayout.SOUTH);
		
		tabbedPane.addTab("image 1", page1);
		tabbedPane.addTab("image 2", page2);
		tabbedPane.addTab("image 3", page3);
		tabbedPane.addTab("image 4", page4);
    tabbedPane.setSelectedIndex(0);         
    
		imagePanel.add(tabbedPane);
	}
	
	public ParamDistributor getParam(){
		System.out.println("valeure de gamma := "+gammaSlider.getValue());
		ParamDistributor param = new ParamDistributor();
		param.setGamma(gammaSlider.getValue());
		param.setBWSeuil(seuilBWSlider.getValue());
		param.setRSeuil(seuilRSlider.getValue());
		param.setGSeuil(seuilGSlider.getValue());
		param.setBSeuil(seuilBSlider.getValue());
		param.setRescale(rescaleBox.isSelected());
		param.setFilter(filteringBox.isSelected());
		param.setNbPasse((new Integer(JTNbPasse.getText())).intValue());
		param.setTailleFiltre((new Integer(JTFilterSize.getText())).intValue());
		
		param.setBorder(fillBorderBox.isSelected());
		param.setBorderValue((new Integer(JTBorderValue.getText())).intValue());
		param.setBorderSize((new Integer(JTBorderSize.getText())).intValue());
		
		param.setColorOpDiff(colorOpDiffSlider.getValue());
		param.setColorOpMinSeuil(colorOpMinSeuilSlider.getValue());
		param.setBlackValue(blackSlider.getValue());
		
		param.setGauche(gauche.isSelected());
		param.setDroite(droite.isSelected());
		param.setDecalageX((new Integer(JTDecalageX.getText())).intValue());
		param.setDecalageY((new Integer(JTDecalageY.getText())).intValue());
		
		param.setRedCylSurf((new Integer(JTSurfRedCyl.getText())).intValue());
		param.setGreenCylSurf((new Integer(JTSurfGreenCyl.getText())).intValue());
		param.setBlueCylSurf((new Integer(JTSurfBlueCyl.getText())).intValue());

		param.setRedBord((new Integer(JTRedBord.getText())).intValue());
		param.setGreenBord((new Integer(JTGreenBord.getText())).intValue());
		param.setBlueBord((new Integer(JTBlueBord.getText())).intValue());

		param.setRobotSizeX((new Integer(JTRobotX.getText())).intValue());
		param.setRobotSizeY((new Integer(JTRobotY.getText())).intValue());
		param.setRobotBord((new Integer(JTBordRobot.getText())).intValue());

		//System.out.println("setting de parametre red : "+SRSeuilMin.getValue()+";"+SRSeuilMax.getValue());
		param.setSelectColorSeuilR(SRSeuilMin.getValue(), SRSeuilMax.getValue());
		param.setSelectColorSeuilG(SGSeuilMin.getValue(), SGSeuilMax.getValue());
		param.setSelectColorSeuilB(SBSeuilMin.getValue(), SBSeuilMax.getValue());

		param.setRequestRed(JCReqRed.isSelected());
		param.setRequestGreen(JCReqGreen.isSelected());
		param.setRequestBlue(JCReqBlue.isSelected());
		param.setRequestWall(JCReqWall.isSelected());
		param.setRequestRobot(JCReqRobot.isSelected());

		param.setLargMaxDoorHoriz((new Integer(JTLargDoorHoriz.getText())).intValue());
		param.setLargMaxDoorVert((new Integer(JTLargDoorVert.getText())).intValue());
		
		param.setQuadrillage(quadrillageBox.isSelected());


		System.out.println("checkBoxVectorSize := "+checkBoxVector.size());
		param.setCalculatedImage(checkBoxVector);

		return param;
	}

	public void setRefImage(Image img1){
		imageRef.changeImage(img1);
	}
	
	public void setNewImage(Vector imageList){
		for (int i=0;i<nbDisplayableImage; i++){
			((ImageDisplayer)imageVector.get(i)).changeImage(((AnalysedImageJAI)imageList.get(i)).getTransformImage());
		}
	}
	
	public JPanel getOptionPanel(){
		JPanel optionPanel = new JPanel();
		JPanel seuilPanel = getSeuilPanel();
		JPanel page1Panel = getPage1OptionPanel();
		
		JPanel rescalePanel = getSecondaryOptionPanel();
		JPanel advanceOptPanel = getAdvanceOption();
		JPanel advanceOptPanel2 = getAdvanceOption2();
		JPanel colorSelectorOption = getColorSelectorOption();
		JPanel robotOption = getRobotOption();
		JPanel imageToCalculate = getImageToCalculate();
		
		
		JTabbedPane tabbedPane = new JTabbedPane();
	  JPanel optionPage1 = new JPanel();
	  JPanel optionPage2 = new JPanel();
	  JPanel optionPage3 = new JPanel();
	  optionPage1.setLayout(new BorderLayout(5,5));
	  optionPage2.setLayout(new BorderLayout(5,5));
	  optionPage3.setLayout(new BorderLayout(5,5));
	  
		optionPage1.add(seuilPanel,BorderLayout.WEST);
		optionPage1.add(page1Panel,BorderLayout.CENTER);
		optionPage1.add(rescalePanel,BorderLayout.EAST);
		
		optionPage2.add(advanceOptPanel,BorderLayout.WEST);
		optionPage2.add(advanceOptPanel2,BorderLayout.EAST);
		
		optionPage3.add(colorSelectorOption,BorderLayout.NORTH);
		optionPage3.add(robotOption,BorderLayout.WEST);
		optionPage3.add(imageToCalculate,BorderLayout.EAST);
		
		tabbedPane.addTab("option 1", optionPage1);
		tabbedPane.addTab("option 2", optionPage2);
		tabbedPane.addTab("option 3", optionPage3);
    tabbedPane.setSelectedIndex(0);      
		
		optionPanel.add(tabbedPane);
		
		return optionPanel;
	}
	
	public JPanel getPage1OptionPanel(){
		JPanel optionPanel = new JPanel();
		JPanel gammaPanel = getGammaPanel();
		JPanel requestOptPanel = getRequestOptionPanel();
		optionPanel.setLayout(new BorderLayout(2,2));
		optionPanel.add(requestOptPanel, BorderLayout.NORTH);
		optionPanel.add(gammaPanel, BorderLayout.CENTER);
		
		return optionPanel;
	}
	
	public JPanel getAdvanceOption(){
		JPanel optionPanel = new JPanel();
		JPanel checkBoxPanel = new JPanel();
		foundRegionBox = new JCheckBox("found region ?");
		quadrillageBox = new JCheckBox("Quadrillage ?");
		
		JPanel colorOpPanel = getColorOpOption();
		JPanel blackOptionPanel = getBlackOption();
		
		checkBoxPanel.setLayout(new GridLayout(1,2));
		checkBoxPanel.add(foundRegionBox);
		checkBoxPanel.add(quadrillageBox);
		
		quadrillageBox.setSelected(true);
		
		optionPanel.setLayout(new BorderLayout(5,5));
		optionPanel.setBorder(BorderFactory.createTitledBorder("option"));
	
		optionPanel.add(checkBoxPanel,BorderLayout.NORTH);
		optionPanel.add(colorOpPanel,BorderLayout.CENTER);
		optionPanel.add(blackOptionPanel,BorderLayout.SOUTH);
		
		return optionPanel;
	}
	
	public JPanel getAdvanceOption2(){
		JPanel optionPanel = new JPanel();
		JPanel wallPanel = getWallOption();
		JPanel cylinderPanel = getCylinderOption();
		
		optionPanel.setLayout(new BorderLayout(5,5));
		optionPanel.setBorder(BorderFactory.createTitledBorder("option"));
	
		optionPanel.add(wallPanel,BorderLayout.NORTH);
		optionPanel.add(cylinderPanel,BorderLayout.CENTER);
		
		return optionPanel;
	}
	
	public JPanel getSecondaryOptionPanel(){
		JPanel optionPanel = new JPanel();
		JPanel filterOption = getFilteringOption();
		JPanel borderOption = getBorderOption();
		
		optionPanel.setLayout(new BorderLayout(5,5));
		optionPanel.setBorder(BorderFactory.createTitledBorder("option"));
		
		rescaleBox = new JCheckBox("rescaling ?");
		
		optionPanel.add(rescaleBox,BorderLayout.NORTH);
		optionPanel.add(borderOption,BorderLayout.CENTER);
		optionPanel.add(filterOption,BorderLayout.SOUTH);
		return optionPanel;
	}


// =========================================================================	
	public JPanel getImageToCalculate(){
		JPanel calculatePanel = new JPanel();
		checkBoxVector = new Vector();
		int nbLigne = Math.round(nbDisplayableImage/4);
		int nbColonne = Math.round(nbDisplayableImage/nbLigne);
		
		System.out.println("nombre de ligne: "+nbLigne+" nb colonne "+nbColonne);
		calculatePanel.setLayout(new GridLayout(nbLigne,nbColonne));
		for (int i=0;i<nbDisplayableImage; i++){
			JCheckBox currentBox =new JCheckBox(((ImageDisplayer)imageVector.get(i)).getName());
			checkBoxVector.add(currentBox);
			calculatePanel.add(currentBox);
		}
		for (int i=0;i<nbDisplayableImage; i++){
			((JCheckBox)checkBoxVector.get(i)).setSelected(true);
		}
		
		calculatePanel.setBorder(BorderFactory.createTitledBorder("Image a calculer"));
		return calculatePanel;
	}
	
	
	public JPanel getRequestOptionPanel(){
		JPanel requestPanel = new JPanel();
		JPanel reqOptPanel = new JPanel();
		
		JCReqRed = new JCheckBox("request red Cylinder");
		JCReqGreen = new JCheckBox("request green Cylinder");
		JCReqBlue = new JCheckBox("request blue Cylinder");
		JCReqWall = new JCheckBox("request wall");
		JCReqRobot = new JCheckBox("request robot");
				
		JCReqRed.setSelected(true);
		JCReqGreen.setSelected(true);
		JCReqBlue.setSelected(true);
		JCReqWall.setSelected(true);
		JCReqRobot.setSelected(true);
		
		reqOptPanel.setLayout(new GridLayout(5,1));
		reqOptPanel.add(JCReqRed);
		reqOptPanel.add(JCReqGreen);
		reqOptPanel.add(JCReqBlue);
		reqOptPanel.add(JCReqWall);
		reqOptPanel.add(JCReqRobot);
		
		requestPanel.setBorder(BorderFactory.createTitledBorder("Request"));
		requestPanel.add(reqOptPanel);
		return requestPanel;
	}
	
	
/// FINIR DE METTRE TOUTES LES OPTIONS....
	public JPanel getRobotOption(){
		JPanel robotPanel = new JPanel();
		JPanel robotOptPanel = new JPanel();
		JLabel JLRobotX = new JLabel("taille robot en X: ");
		JLabel JLRobotY = new JLabel("taille robot en Y: ");
		JLabel JLBordRobot = new JLabel("bord a eviter: ");
		JLabel JLDistSearchRobot = new JLabel("limite des bord: ");
		
		JTRobotX = new JTextField(initRobotX);
		JTRobotY = new JTextField(initRobotY);
		JTBordRobot = new JTextField(initBordRobot);
		
		robotPanel.setBorder(BorderFactory.createTitledBorder("option du robot"));
		
		robotOptPanel.setLayout(new GridLayout(4,2));
		robotOptPanel.add(JLRobotX);
		robotOptPanel.add(JTRobotX);
		robotOptPanel.add(JLRobotY);
		robotOptPanel.add(JTRobotY);
		robotOptPanel.add(JLBordRobot);
		robotOptPanel.add(JTBordRobot);
		robotOptPanel.add(JLDistSearchRobot);
		
		robotPanel.add(robotOptPanel);
		return robotPanel;
	}
	
	public JPanel getColorSelectorOption(){
		JPanel cSOption = new JPanel();		
		JPanel sliderPanel = new JPanel();
		
		sliderPanel.setLayout(new GridLayout(3,3));
		
		SRSeuilMin = new JSlider(0,255,initRSeuilMin);
		SRSeuilMax = new JSlider(0,255,initRSeuilMax);
		SGSeuilMin = new JSlider(0,255,initGSeuilMin);
		SGSeuilMax = new JSlider(0,255,initGSeuilMax);
		SBSeuilMin = new JSlider(0,255,initBSeuilMin);
		SBSeuilMax = new JSlider(0,255,initBSeuilMax);
		
		JLabel JLSeuilR = new JLabel("seuil min max rouge");
		JLabel JLSeuilG = new JLabel("seuil min max vert");
		JLabel JLSeuilB = new JLabel("seuil min max bleu");
		
		cSOption.setBorder(BorderFactory.createTitledBorder("option de selection des couleurs"));
		
		sliderPanel.add(JLSeuilR);
		sliderPanel.add(JLSeuilG);
		sliderPanel.add(JLSeuilB);
		sliderPanel.add(SRSeuilMin);
		sliderPanel.add(SGSeuilMin);
		sliderPanel.add(SBSeuilMin);
		sliderPanel.add(SRSeuilMax);
		sliderPanel.add(SGSeuilMax);
		sliderPanel.add(SBSeuilMax);
		
		SRSeuilMin.setPaintTicks(true);
		SRSeuilMin.setPaintLabels(true);
		SRSeuilMin.setMajorTickSpacing(30);
		SRSeuilMin.setMinorTickSpacing(1); 
		SRSeuilMax.setPaintTicks(true);
		SRSeuilMax.setPaintLabels(true);
		SRSeuilMax.setMajorTickSpacing(30);
		SRSeuilMax.setMinorTickSpacing(1); 
		SGSeuilMin.setPaintTicks(true);
		SGSeuilMin.setPaintLabels(true);
		SGSeuilMin.setMajorTickSpacing(30);
		SGSeuilMin.setMinorTickSpacing(1); 
		SGSeuilMax.setPaintTicks(true);
		SGSeuilMax.setPaintLabels(true);
		SGSeuilMax.setMajorTickSpacing(30);
		SGSeuilMax.setMinorTickSpacing(1); 
		SBSeuilMin.setPaintTicks(true);
		SBSeuilMin.setPaintLabels(true);
		SBSeuilMin.setMajorTickSpacing(30);
		SBSeuilMin.setMinorTickSpacing(1); 
		SBSeuilMax.setPaintTicks(true);
		SBSeuilMax.setPaintLabels(true);
		SBSeuilMax.setMajorTickSpacing(30);
		SBSeuilMax.setMinorTickSpacing(1); 
		
		cSOption.add(sliderPanel);
		return cSOption;
	}
	
	public JPanel getCylinderOption(){
		JPanel cylinderPanel = new JPanel();
		JPanel cylinderOption1 = new JPanel();
		JPanel cylinderOption2 = new JPanel();
		
		JLabel JLSurfRedCyl = new JLabel("surface cylindre rouge: ");
		JTSurfRedCyl = new JTextField("15");
		JLabel JLSurfGreenCyl = new JLabel("surface cylindre vert: ");
		JTSurfGreenCyl = new JTextField("15");
		JLabel JLSurfBlueCyl = new JLabel("surface cylindre bleu: ");
		JTSurfBlueCyl = new JTextField("15");
		JLabel JLRedTolerance = new JLabel("tolerance sur le rouge");
		JTRedTolerance = new JTextField("250");
		JLabel JLGreenTolerance = new JLabel("tolerance sur le vert");
		JTGreenTolerance = new JTextField("250");
		JLabel JLBlueTolerance = new JLabel("tolerance sur le bleu");
		JTBlueTolerance = new JTextField("250");
		JLabel JLRedBord = new JLabel("bord de recherche rouge");
		JTRedBord = new JTextField("20");
		JLabel JLGreenBord = new JLabel("bord de recherche vert");
		JTGreenBord = new JTextField("20");
		JLabel JLBlueBord = new JLabel("bord de recherche bleu");
		JTBlueBord = new JTextField("20");
		
		cylinderOption1.setLayout(new GridLayout(3,4));
		cylinderOption1.add(JLSurfRedCyl);
		cylinderOption1.add(JTSurfRedCyl);
		cylinderOption1.add(JLSurfGreenCyl);
		cylinderOption1.add(JTSurfGreenCyl);
		cylinderOption1.add(JLSurfBlueCyl);
		cylinderOption1.add(JTSurfBlueCyl);
				
		cylinderOption1.add(JLRedTolerance);
		cylinderOption1.add(JTRedTolerance);
		cylinderOption1.add(JLGreenTolerance);
		cylinderOption1.add(JTGreenTolerance);
		cylinderOption1.add(JLBlueTolerance);
		cylinderOption1.add(JTBlueTolerance);
		
		cylinderOption2.setLayout(new GridLayout(3,2));
		cylinderOption2.add(JLRedBord);
		cylinderOption2.add(JTRedBord);
		cylinderOption2.add(JLGreenBord);
		cylinderOption2.add(JTGreenBord);
		cylinderOption2.add(JLBlueBord);
		cylinderOption2.add(JTBlueBord);
		
		cylinderPanel.setLayout(new BorderLayout(2,2));
		cylinderPanel.add(cylinderOption1,BorderLayout.NORTH);
		cylinderPanel.add(cylinderOption2,BorderLayout.SOUTH);
		return cylinderPanel;
	}
	
	
	public JPanel getWallOption(){
		JPanel wallPanel = new JPanel();
		JPanel posOptionPanel = new JPanel();
		JPanel wallOptionPanel = new JPanel();
		
		JLabel JLDecalageX = new JLabel("decalage recherche x:");
		JLabel JLDecalageY = new JLabel("decalage recherche y:");
		JLabel JLLargeurDoorHoriz = new JLabel("largeur amx porte horiz:");
		JLabel JLLargeurDoorVert = new JLabel("largeur amx porte vert:");
		
		JLabel JLQuest = new JLabel("position du mur");

		JTDecalageX = new JTextField(initDecalageX);
		JTDecalageY = new JTextField(initDecalageY);
		
		JTLargDoorHoriz = new JTextField(initLargDoorHoriz);
		JTLargDoorVert = new JTextField(initLargDoorVert);
		
		wallPanel.setBorder(BorderFactory.createTitledBorder("option de detection des murs"));
		
		ButtonGroup groupeGD = new ButtonGroup();
		gauche = new JCheckBox("a gauche");
		droite = new JCheckBox("a droite");
		groupeGD.add(gauche);
		groupeGD.add(droite);
		gauche.setSelected(false);
		droite.setSelected(true);
		
		posOptionPanel.setLayout(new GridLayout(1,2));
		posOptionPanel.add(gauche);
		posOptionPanel.add(droite);
		
		wallOptionPanel.setLayout(new GridLayout(4,2));
		wallOptionPanel.add(JLDecalageX);
		wallOptionPanel.add(JTDecalageX);
		wallOptionPanel.add(JLDecalageY);
		wallOptionPanel.add(JTDecalageY);
		wallOptionPanel.add(JLLargeurDoorHoriz);
		wallOptionPanel.add(JTLargDoorHoriz);
		wallOptionPanel.add(JLLargeurDoorVert);
		wallOptionPanel.add(JTLargDoorVert);	
		
		wallPanel.add(JLQuest,BorderLayout.NORTH);
		wallPanel.add(posOptionPanel,BorderLayout.CENTER);
		wallPanel.add(wallOptionPanel,BorderLayout.SOUTH);
		
		return wallPanel;
	}
	
	
	public JPanel getBlackOption(){
		JPanel blackPanel = new JPanel();
		JPanel optionBlackPanel = new JPanel();
		blackPanel.setLayout(new BorderLayout(5,5));
		optionBlackPanel.setLayout(new GridLayout(2,2));
		
		blackSlider = new JSlider(0,255,initBlackSlider);
				
		blackSlider.setPaintTicks(true);
		blackSlider.setPaintLabels(true);
		blackSlider.setMajorTickSpacing(30);
		blackSlider.setMinorTickSpacing(1); 
		
		JLabel JLBlack = new JLabel("seuil des couleurs");
		blackPanel.setBorder(BorderFactory.createTitledBorder("all color selection"));
		
		optionBlackPanel.add(JLBlack);
		optionBlackPanel.add(blackSlider);
	
		blackPanel.add(optionBlackPanel,BorderLayout.SOUTH);
		
		return blackPanel;
	}

	public JPanel getColorOpOption(){
		JPanel colorOpPanel = new JPanel();
		JPanel optionColorOpPanel = new JPanel();
		colorOpPanel.setLayout(new BorderLayout(5,5));
		optionColorOpPanel.setLayout(new GridLayout(2,2));

		colorOpDiffSlider = new JSlider(0,255,initcolorOpDiffSlider);
		colorOpMinSeuilSlider = new JSlider(0,255,initcolorOpMinSeuilSlider);
		
		colorOpDiffSlider.setPaintTicks(true);
		colorOpDiffSlider.setPaintLabels(true);
		colorOpDiffSlider.setMajorTickSpacing(30);
		colorOpDiffSlider.setMinorTickSpacing(1); 
		
		colorOpMinSeuilSlider.setPaintTicks(true);
		colorOpMinSeuilSlider.setPaintLabels(true);
		colorOpMinSeuilSlider.setMajorTickSpacing(30);
		colorOpMinSeuilSlider.setMinorTickSpacing(1); 
		
		JLabel JLcolorOpDiff = new JLabel("diff entre couleur");
		JLabel JLcolorOpMinSeuil = new JLabel("seuil minimale");
		colorOpPanel.setBorder(BorderFactory.createTitledBorder("color operator"));
		
		optionColorOpPanel.add(JLcolorOpDiff);
		optionColorOpPanel.add(colorOpDiffSlider);
		optionColorOpPanel.add(JLcolorOpMinSeuil);
		optionColorOpPanel.add(colorOpMinSeuilSlider);
	
		colorOpPanel.add(optionColorOpPanel,BorderLayout.SOUTH);
		
		return colorOpPanel;
	}
	
	public JPanel getBorderOption(){
		JPanel borderPanel = new JPanel();
		JPanel optionBorderPanel = new JPanel();
		borderPanel.setLayout(new BorderLayout(5,5));
		optionBorderPanel.setLayout(new GridLayout(2,2));
		
		fillBorderBox =new JCheckBox("border ?");
		JTBorderSize = new JTextField("0");
		JLabel JLBorderSize = new JLabel("largeur du bord");
		JTBorderValue = new JTextField("0");
		JLabel JLBorderValue = new JLabel("valeur dans les bord");
		borderPanel.setBorder(BorderFactory.createTitledBorder("bordure"));
		
		optionBorderPanel.add(JLBorderSize);
		optionBorderPanel.add(JTBorderSize);
		optionBorderPanel.add(JLBorderValue);
		optionBorderPanel.add(JTBorderValue);
	
		borderPanel.add(fillBorderBox,BorderLayout.NORTH);
		borderPanel.add(optionBorderPanel,BorderLayout.SOUTH);
		
		return borderPanel;
	}
	
	public JPanel getFilteringOption(){
		JPanel filterPanel = new JPanel();
		JPanel optionFilterPanel = new JPanel();
		filterPanel.setLayout(new BorderLayout(5,5));
		optionFilterPanel.setLayout(new GridLayout(2,2));
		
		filteringBox = new JCheckBox("filtering ?");
		JTNbPasse  = new JTextField("2");
		JLabel JLNbPasse = new JLabel("nombre de passe: ");
		JTFilterSize  = new JTextField("3");
		JLabel JLFilterSize = new JLabel("taille du filtre: ");
		filterPanel.setBorder(BorderFactory.createTitledBorder("filtrage"));
		
		filteringBox.setSelected(true);
		
		optionFilterPanel.add(JLNbPasse);
		optionFilterPanel.add(JTNbPasse);
		optionFilterPanel.add(JLFilterSize);
		optionFilterPanel.add(JTFilterSize);
		
		filterPanel.add(filteringBox,BorderLayout.NORTH);
		filterPanel.add(optionFilterPanel,BorderLayout.SOUTH);
		
		return filterPanel;
	}
	
	public JPanel getSeuilPanel(){
		JPanel seuilPanel = new JPanel();
		JPanel optionPanel = new JPanel();
		JPanel seuilLabelPanel = new JPanel();
		JPanel seuilTextPanel = new JPanel();
		
		JLabel JL_seuilBW = new JLabel("seuil du noir: ");
		JLabel JL_seuilR = new JLabel("seuil du rouge: ");
		JLabel JL_seuilG = new JLabel("seuil du vert: ");
		JLabel JL_seuilB = new JLabel("seuil du bleu: ");
	
		seuilBWSlider = new JSlider(0,255,initSeuilBWSlider);
		seuilRSlider = new JSlider(0,255,initSeuilRSlider);
		seuilGSlider = new JSlider(0,255,initSeuilGSlider);
		seuilBSlider = new JSlider(0,255,initSeuilBSlider);
		
		seuilBWSlider.setPaintTicks(true);
		seuilBWSlider.setPaintLabels(true);
		seuilBWSlider.setMajorTickSpacing(30);
		seuilBWSlider.setMinorTickSpacing(1); 
		seuilRSlider.setPaintTicks(true);
		seuilRSlider.setPaintLabels(true);
		seuilRSlider.setMajorTickSpacing(30);
		seuilRSlider.setMinorTickSpacing(1); 
		seuilGSlider.setPaintTicks(true);
		seuilGSlider.setPaintLabels(true);
		seuilGSlider.setMajorTickSpacing(30);
		seuilGSlider.setMinorTickSpacing(1); 
		seuilBSlider.setPaintTicks(true);
		seuilBSlider.setPaintLabels(true);
		seuilBSlider.setMajorTickSpacing(30);
		seuilBSlider.setMinorTickSpacing(1); 
		
		seuilPanel.setBorder(BorderFactory.createTitledBorder("parametre de seuillage"));

		optionPanel.setLayout(new GridLayout(1,3,2,2));
		seuilPanel.setLayout(new BorderLayout(3,3));
		seuilLabelPanel.setLayout(new GridLayout(4,1,3,3));
		seuilTextPanel.setLayout(new GridLayout(4,1,3,3));
				
		seuilLabelPanel.add(JL_seuilBW);
		seuilLabelPanel.add(JL_seuilR);
		seuilLabelPanel.add(JL_seuilG);
		seuilLabelPanel.add(JL_seuilB);
		
		seuilTextPanel.add(seuilBWSlider);
		seuilTextPanel.add(seuilRSlider);
		seuilTextPanel.add(seuilGSlider);
		seuilTextPanel.add(seuilBSlider);
		
		seuilPanel.add(seuilLabelPanel,BorderLayout.WEST);
		seuilPanel.add(seuilTextPanel,BorderLayout.EAST);
	 	seuilPanel.add(optionPanel, BorderLayout.NORTH);
	 
	 	return seuilPanel;
	}
		
	public JPanel getGammaPanel(){
		JPanel gammaPanel = new JPanel();
		
		JLabel JL_gamma = new JLabel("valeur de gamma: ");
		gammaSlider = new JSlider(-6,6,initGammaValue);
		gammaSlider.setPaintTicks(true);
		gammaSlider.setPaintLabels(true);
		gammaSlider.setMajorTickSpacing(2);
		gammaSlider.setMinorTickSpacing(1); 

		gammaPanel.setBorder(BorderFactory.createTitledBorder("parametre gamma"));

		gammaPanel.setLayout(new BorderLayout(3,3));
	
		gammaPanel.add(JL_gamma,BorderLayout.NORTH);
		gammaPanel.add(gammaSlider,BorderLayout.SOUTH);
	 	
	 	return gammaPanel;
	}

	public void actionPerformed(ActionEvent e){
		if (e.getSource()== imageName[0]){
			imageRef.setVisible(imageName[0].isSelected());
		}
		for (int i=1; i<imageName.length; i++){
			if (e.getSource()== imageName[i]){
				((ImageDisplayer)imageVector.get(i-1)).setVisible(imageName[i].isSelected());
				System.out.println("cacher image "+i);
			}
		}
	}
}
