/* EHRLER FREDERIC - MICHEL DERIAZ
 * ------------------------------------------------------------------
 * cette classe permet comme la classe affiche image de creer un panel 
 * dans lequel on affiche une image, mais cette classe est un peu plus
 * evoluee car elle prend en compte les BufferedImage, ainsi que different
 * parametre qui nous indique si l'image doit etre affichee ou non
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.image.*;
public class ImageDisplayer extends JPanel{
	Image image;
	BufferedImage image2;
	String name;
	boolean isVisible = true;
	boolean affiche = false;
	boolean afficheBuff = false;
	int dimX;
	int dimY;
	
	public ImageDisplayer(int dimX, int dimY){
		setPreferredSize(new Dimension(dimX,dimY));
		this.dimX = dimX;
		this.dimY = dimY;
		affiche = false;
		afficheBuff = false;
	}
	
	public ImageDisplayer(Image im){
		affiche= true;
		image = im;
		repaint();
	}
	
	public ImageDisplayer(BufferedImage im){
		//System.out.println("creation d'un imageDisplayer pour une buffered Image");
		afficheBuff= true;
		image2 = im;
		repaint();
	}


	public void setName(String name){
		this.name = name;
	}
	
	public String getName(){
		return name;
	}
	
	public void setVisible(boolean isVisible){
		this.isVisible = isVisible;
	}
	
	public void changeImage(Image im){
		affiche= true;
		//System.out.println("Changement d'image de l'imageDisplayer");
		image = im;
		repaint();
	}
	
	public void changeImage(BufferedImage im){
		afficheBuff= true;
		//System.out.println("Changement d'image de l'imageDisplayer");
		image2 = im;
		repaint();
	}

	public void paintComponent(Graphics g){
		super.paintComponent(g);
		if (isVisible){
			if (affiche){
				//System.out.println("affichage de l'image");
				g.drawImage(image, 0, 0, this);
			}
			if (afficheBuff){
				//System.out.println("affichage de l'image bufffered");
				g.drawImage(image2, 0, 0, this);
			}
		}
	}		
}